import { WebConfig } from "makecode-core/built/downloader";
import { BuiltSimJsInfo, CompileOptions, CompileResult } from "makecode-core/built/service";
import { LanguageService, SimpleDriverCallbacks } from "makecode-core/built/host";
import { DownloadedEditor, Package } from "makecode-core";
export declare class BrowserLanguageService implements LanguageService {
    editor: DownloadedEditor;
    protected nextID: number;
    protected pendingMessages: {
        [index: string]: (response: ClientToWorkerRequestResponse) => void;
    };
    protected worker: Worker;
    protected driverCallbacks: SimpleDriverCallbacks;
    constructor(editor: DownloadedEditor);
    dispose(): void;
    registerDriverCallbacksAsync(callbacks: SimpleDriverCallbacks): Promise<void>;
    setWebConfigAsync(config: WebConfig): Promise<void>;
    getWebConfigAsync(): Promise<WebConfig>;
    getAppTargetAsync(): Promise<any>;
    getTargetConfigAsync(): Promise<any>;
    supportsGhPackagesAsync(): Promise<boolean>;
    setHwVariantAsync(variant: string): Promise<void>;
    getHardwareVariantsAsync(): Promise<pxt.PackageConfig[]>;
    getBundledPackageConfigsAsync(): Promise<pxt.PackageConfig[]>;
    getCompileOptionsAsync(prj: Package, simpleOpts?: any): Promise<CompileOptions>;
    installGhPackagesAsync(projectFiles: pxt.Map<string>): Promise<pxt.Map<string>>;
    setProjectTextAsync(projectFiles: pxt.Map<string>): Promise<void>;
    performOperationAsync(op: string, options: any): Promise<any>;
    enableExperimentalHardwareAsync(): Promise<void>;
    enableDebugAsync(): Promise<void>;
    setCompileSwitchesAsync(flags: string): Promise<void>;
    buildSimJsInfoAsync(result: CompileResult): Promise<BuiltSimJsInfo>;
    protected sendWorkerRequestAsync(message: ClientToWorkerRequest): Promise<ClientToWorkerRequestResponse>;
    protected onWorkerResponseReceived(message: ClientToWorkerRequestResponse): void;
    protected onWorkerRequestReceived(message: WorkerToClientRequest): Promise<void>;
    protected sendWorkerRequestResponse(message: WorkerToClientRequestResponse): void;
}
